"""   +=================-=========-=========-=========*=========-=========-=========-=================+
      ||                                       INPUT and OUTPUT                                      ||
      ||                                                                                             ||
      +=================-=========-=========-=========*=========-=========-=========-=================+


PART I INPUT.
   For debugging purposes and most school problems, you do NOT want to do any kind on input--it is too in-
efficient and time consuming. Hard coding is the way to go. However, INPUT via dialogue box is done like this:

                str =       input ('Type in a string.')
                num = int  (input ('Type in an   int.'))
                flt = float(input ('Type in a  float.'))

   And a float cast will work for both integer and float types.

   NOTE WELL: Check input values for validity. Computer guru Steve McConnel notes that "Garbage in, garbage
out" is not a good policy. Better is "no garbage in." or "garbage in, try again", or "garbage in, error
message", or "garbage in, and the program aborts."

                         A dead program normally does a lot less damage than a
                         crippled one.--Andy Hunt and Dave Thomas, The Pragmatic
                         Programmer (Addison-Wesley, 1999), page ?.

   Below are two different ways to check-and-filter input. In the try/except/else block, either the EXCEPT
   part or the ELSE part will be run (but not both).

#---Input with a filter (method 1).
    flag = True
    s = 'Enter an integer:'
    while flag:
      try:
        num = int(input(s))
      except:
        s = 'That was NOT an integer! Try again.\nEnter an integer: '
      else:
        flag = False

#---Input with a filter (method 2).
    stng1 ="Enter code (= c), or decode (= d). ";
    stng2 = stng1
    while True:
       mode = input (stng2)
       if mode in ('c', 'd'): break
       stng3 = "BAD INPUT: " + mode + ". Try again. "
       stng2 = stng1 + stng3
    print ("OK, you are in.")
    --------------------------------------------------------------------------


PART II OUTPUT.
   Output in the console window is done like this:

                                print(1,2,3)

   You can control the optional string separator and the end-of-line char-
acter(s) like this:
                    print(1,2,3, sep = ', ', end = '\n')

   The '\n ' is the command for "move the cursor go to the beginning of the next
line".
    --------------------------------------------------------------------------

PART III FORMATTING (See the Formatting section.)
