"""
    +---------------------------------------------------------------------------------+
    |                                                                                 |\
    |                      /^\/^\                                                     |\\
    |                    _|__|  O|        THE PYTHON REFERENCE BOOK OF                |\\|
    |                  /~     \_/ \         TIPS, TRICKS, AND TRAPS                   |\\|
    |                 |__________/  \                                                 |\\|
    |                   \_______      \                                               |\\|
    |                           `\     \                 \                            |\\|
    |                             |     |                  \                          |\\|
    |                            /      /        by          \                        |\\|
    |                           /     /      M. Stueben        \\                     |\\|
    |                         /      /   mastueben@fcps.edu    \ \                    |\\|
    |                        /     /                            \  \                  |\\|
    |                      /     /             _----_            \   \                |\\|
    |                     /     /           _-~      ~-_         |   |                |\\|
    |                    (      (        _-~    _--_    ~-_     _/   |                |\\|
    |                     \      ~-____-~    _-~    ~-_    ~-_-~    /                 |\\|
    |                       \     ~--______-~                ~-___-~                  |\\|
    |                                       (August 23 2013)                          |\\|
    +---------------------------------------------------------------------------------+\\|
     \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\|
      \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\|
       ----------------------------------------------------------------------------------+

   An electronic copy of this manuscript can be downloaded at

                       http://academics.tjhsst.edu/compsci/ai/.

   A listing of built-in functions for each module, and detailed information about each
function can be obtained with these two commands (using the math module as an example):

                              print(dir('math'))
                              help('math')

                                     INDEX                                page
  1. THE BASIC PYTHON PROGRAM (notes and examples for beginners)........... 1
  2. BIT TWIDDLING.........................................................
  3. BOOLEANS (see IF).....................................................
  4. BUILT-IN FUNCTIONS (See STRINGS and NUMBERS)..........................
  5. CLASSES and OOP.......................................................
  6. COMPREHENSIONS (See functional programming)...........................
  7. DECIMAL TYPE (see HIGH PRECISION COMPUTING)...........................
  8. DICTIONARIES..........................................................
  9. EXCEPTIONS............................................................
 10. EVAL..................................................................
 11. FILES.................................................................
 12. FORMATTING OUTPUT (both % and format).................................
 13. FUNCTIONAL PROGRAMMING (comprehensions, map, lambda, and filter)......
 14. FUNCTIONS.............................................................
 15. GENERATORS and YIELD..................................................
 16. GRAPHICS and ANIMATION (also see PYGAME and  WX GRAPHICS) ............
 17. HEAPS.................................................................
 18. HIGH PRECISION COMPUTATION (Decimal type).............................
 19. IF, ELSE, ELIF, and BOOLEAN...........................................
 20. INPUT and OUTPUT......................................................
 21. LAMBDA (See functional programming)...................................
 22. LISTS, TUPLES, and ARRAYS (also see Queues)...........................
 23. LIST COMPREHENSIONS (See functional programming)......................
 24. LOOPS (for and while).................................................
 25. MAP (See functional programming)......................................
 26. MATRICES (creating and transposing)...................................
 27. NUMBERS (int, float, decimal, complex, and their functions)...........
 28. POLYMORPHISM..........................................................
 29. PYGAME................................................................
 30. PROGRAMMING PHILOSOPHY (style and advice).............................
 31. QUEUES (also see lists) ..............................................
 32. RANDOM, CHOICE, SHUFFLE, and PERMUTATIONS.............................
 33. RECURSION.............................................................
 34. REGULAR EXPRESSIONS...................................................
 35. SEARCHING (HILL CLIMBING, DFS, BFS, and A*)...........................
 36. SETS..................................................................
 37. SLICING (see LISTS and STRINGS).......................................
 38. SORTING...............................................................
 39. SOUND and MUSIC.......................................................
 40. STRINGS (also see Unicode)............................................
 41. TIME, CLOCK, and TIMEIT...............................................
 42. Tk GRAPHICS (See GRAPHICS)............................................
 43. TRANSLATE and MAKETRANS...............................................
 44  TREES.................................................................
 45. TURTLE GRAPHICS.......................................................
 46. TYPE TESTING (both type() and isinstance())...........................
 47. UNICODE (UTF-8, ASCII, Latin-1, etc.).................................
 48. VARIABLES.............................................................
 49. WX GRAPHICS...........................................................
 50. ZIP...................................................................
                                   *  *  *





